//version: 3.56
using System;
using System.Data;
using System.Runtime.InteropServices;
using System.Text;
using System.IO;
using System.Collections;
using System.Reflection;
using System.Windows.Forms;
using System.Drawing;
using System.Threading;
using Microsoft.WindowsCE.Forms;
namespace System
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class Hardware:IDisposable
	{
		public double DLLVersion
		{
			get {return 3.56;}
		}
		private object sip;// = new Microsoft.WindowsCE.Forms.InputPanel();
		public event EventHandler SIPChanged;
		private object[] eventObject;
		private double fixY = 1;
		private double scaleX = 1;
		private double scaleY = 1;

		public Hardware()
		{
			eventObject = new object[] {this,"SIPChanged"};
			try
			{
				sip = new Microsoft.WindowsCE.Forms.InputPanel();
				((InputPanel)sip).EnabledChanged += new EventHandler(sip_EnabledChanged);
				fixY = (double)(Thread.GetData(Thread.GetNamedDataSlot("fixY")));
				scaleX = (double)(Thread.GetData(Thread.GetNamedDataSlot("scaleX")));
				scaleY = (double)(Thread.GetData(Thread.GetNamedDataSlot("scaleY")));
			}
			catch
			{
				sip = null;
			}
		}
		public bool SIPEnabled
		{
			get
			{
				if (sip != null)
					 return ((InputPanel)sip).Enabled;
				else
					return false;
			}
			set
			{
				if (sip != null)
					((InputPanel)sip).Enabled = value;
			
			}
		}
		public int SIPHeight
		{
			get {return (int)(((InputPanel)sip).Bounds.Height / fixY);}
		}
		

		[DllImport("coredll.dll")]

		private static extern Int32 SetForegroundWindow(int hWnd);

		[DllImport("coredll.dll", EntryPoint="GetDesktopWindow")]

		private static extern int GetDesktopWindow(); 
		public void ShowTodayScreen()
		{
            SetForegroundWindow(GetDesktopWindow()); 
		}
		
		private static Int32 FILE_DEVICE_HAL = 0x00000101;
		private static Int32 FILE_ANY_ACCESS = 0x0;
		private static Int32 METHOD_BUFFERED = 0x0;

		private static Int32 IOCTL_HAL_GET_DEVICEID = 
			((FILE_DEVICE_HAL) << 16) | ((FILE_ANY_ACCESS) << 14) 
			| ((21) << 2) | (METHOD_BUFFERED);


		[DllImport("coredll.dll")]
		private static extern bool KernelIoControl(Int32 IoControlCode, IntPtr
			InputBuffer, Int32 InputBufferSize, byte[] OutputBuffer, Int32
			OutputBufferSize, ref Int32 BytesReturned);
		
		public string[] GetStorageCards ()
		{
			DirectoryInfo rootDir = new DirectoryInfo(@"\");
			FileAttributes attrStorageCard = FileAttributes.Directory |
				FileAttributes.Temporary;
			ArrayList al = new ArrayList();
			foreach( FileSystemInfo fsi in rootDir.GetFileSystemInfos() )
			{
				if ( (fsi.Attributes & attrStorageCard) == attrStorageCard )
				{
					al.Add(fsi.FullName);
				}
			}
			return (string[])al.ToArray(typeof(string));
		}

		public string GetDeviceID()
		{
			byte[] OutputBuffer = new byte[256];
			Int32 OutputBufferSize, BytesReturned;
			OutputBufferSize = OutputBuffer.Length;
			BytesReturned = 0;
			bool retVal = KernelIoControl(IOCTL_HAL_GET_DEVICEID, 
				IntPtr.Zero,
				0,
				OutputBuffer,
				OutputBufferSize,
				ref BytesReturned);

			// If the request failed, exit the method now
			if (retVal == false)
			{
				return null;
			}
    
			// Examine the OutputBuffer byte array to find the start of the 
			// Preset ID and Platform ID, as well as the size of the
			// PlatformID. 
			// PresetIDOffset  The number of bytes the preset ID is offset
			//                  from the beginning of the structure
			// PlatformIDOffset - The number of bytes the platform ID is
			//                    offset from the beginning of the structure
			// PlatformIDSize - The number of bytes used to store the
			//                  platform ID
			// Use BitConverter.ToInt32() to convert from byte[] to int
			Int32 PresetIDOffset = BitConverter.ToInt32(OutputBuffer, 4); 
			Int32 PlatformIDOffset = BitConverter.ToInt32(OutputBuffer, 0xc);
			Int32 PlatformIDSize = BitConverter.ToInt32(OutputBuffer, 0x10);

			// Convert the Preset ID segments into a string so they can be 
			// displayed easily.
			StringBuilder sb = new StringBuilder();
			sb.Append(String.Format("{0:X8}-{1:X4}-{2:X4}-{3:X4}-", 
				BitConverter.ToInt32(OutputBuffer, PresetIDOffset), 
				BitConverter.ToInt16(OutputBuffer, PresetIDOffset +4), 
				BitConverter.ToInt16(OutputBuffer, PresetIDOffset +6), 
				BitConverter.ToInt16(OutputBuffer, PresetIDOffset +8))); 

			// Break the Platform ID down into 2-digit hexadecimal numbers
			// and append them to the Preset ID. This will result in a 
			// string-formatted Device ID
			for (int i = PlatformIDOffset; 
				i < PlatformIDOffset +   PlatformIDSize; 
				i ++ )  
			{
				sb.Append( String.Format("{0:X2}", OutputBuffer[i]));
			}
    
			// return the Device ID string
			return sb.ToString();
		}
		
		//*****************Notify
		public int evNone = 0x00; 
		public int evTimeChange = 0x01; 
		public int evSyncEnd = 0x02;
		public int evOnACPower = 0x03;
		public int evOffACPower = 0x04;
		public int evNetConnect = 0x05;
		public int evNetDisconnect = 0x06;
		public int evIRDiscovered = 0x08;
		public int evRS232Detected = 0x09; 
		public int evRestoreEnd = 0x0A; 
		public int evWakeup = 0x0B;
		public int evTimeZoneChange = 0x0C;

		public static void RunAppAtEvent(string AppName, int Event)   
		{   
			if(!CeRunAppAtEvent(AppName, (int)Event))   
			{   
				throw new Exception("Cannot Set Notification Handler");   
			}   
		} 

		public static void RunAppAtTime(string appName, System.Int64 time)   
		{   
			byte[] tb;

			if(time==0)
			{
				//cancel request pass null
				tb = null;
			}
			else
			{
				DateTime dt = new DateTime(time);
				tb = new byte[16];
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Year),0,tb,0,2);
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Month),0,tb,2,2);
				Buffer.BlockCopy(BitConverter.GetBytes(0),0,tb,4,2);
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Day),0,tb,6,2);
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Hour),0,tb,8,2);
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Minute),0,tb,10,2);
				Buffer.BlockCopy(BitConverter.GetBytes(dt.Second),0,tb,12,2);
				Buffer.BlockCopy(BitConverter.GetBytes(0),0,tb,14,2);
			}

			if(!CeRunAppAtTime(appName, tb))   
			{   
				throw new Exception("Cannot Set Notification Handler");   
			}  
		}
		private const int SETPOWERMANAGEMENT   = 6147;
		private const int QUERYESCSUPPORT   = 8;
		public void ScreenOn()
		{
			IntPtr hDC = GetDC(IntPtr.Zero);
			int Esc = QUERYESCSUPPORT;
			if ( ExtEscape(hDC, QUERYESCSUPPORT, Marshal.SizeOf(Esc.GetType()), ref Esc, 0, IntPtr.Zero ) == IntPtr.Zero )
			{
				throw new Exception("This device does not support display power on/off");
			}
			else
			{
				int[] vpm = new int[3];
				vpm[0] = 3 * Marshal.SizeOf(typeof(int));
				vpm[1] = 1;
				vpm[2] = 1;
				ExtEscape(hDC, SETPOWERMANAGEMENT, vpm[0], vpm, 0, IntPtr.Zero);
			}
			ReleaseDC(IntPtr.Zero, hDC);

		}
		private const byte KEYEVENTF_KEYUP = 0x02;
		public void KeyPress (byte KeyCode)
		{
			keybd_event(KeyCode, 0, 0, 0);
			keybd_event(KeyCode, 0, KEYEVENTF_KEYUP, 0);
		}
		public void KeyDown (byte KeyCode)
		{
            keybd_event(KeyCode, 0, 0, 0);            
		}
		public void KeyUp (byte KeyCode)
		{
			keybd_event(KeyCode, 0, KEYEVENTF_KEYUP, 0);
		}
		private IntPtr blHandle;
		public void BackLightOn()
		{
            blHandle = SetPowerRequirement("BKL1:", 0, 1, IntPtr.Zero, 0);
		}
//		public void BackLight(int Power)
//		{
//			blHandle = SetPowerRequirement("BKL1:", Power, 1, IntPtr.Zero, 0);
//		}
		public void BackLightNormal()
		{
			if (blHandle.ToInt32() != 0)
				ReleasePowerRequirement(blHandle);
		}
		public void KeepAlive()
		{
			SHIdleTimerReset();
			SystemIdleTimerReset();
		}


		[DllImport("coredll")]
		private extern static IntPtr GetDC(IntPtr hWnd);
		[DllImport("coredll")]
		private extern static void ReleaseDC(IntPtr hWnd, IntPtr hDC);
		[DllImport("coredll")]
		private extern static IntPtr ExtEscape(IntPtr hDC, int Esc, int cbInData, int[] InData, int cbOutData, IntPtr OutData);
		[DllImport("coredll")]
		private extern static IntPtr ExtEscape(IntPtr hDC, int Esc, int cbInData, ref int InData, int cbOutData, IntPtr OutData);
		
  
		[DllImport("coredll.dll", EntryPoint="CeRunAppAtEvent", SetLastError=true)]   
		private static extern bool CeRunAppAtEvent(string pwszAppName, int lWhichEvent);   
    
		[DllImport("coredll.dll", EntryPoint="CeRunAppAtTime", SetLastError=true)]   
		private static extern bool CeRunAppAtTime(string pwszAppName, byte[] lpTime);   
		[DllImport("coredll.dll", EntryPoint = "SystemIdleTimerReset")] 
		private static extern void SystemIdleTimerReset(); 
		[DllImport("aygshell.dll", SetLastError=true)]
		private static extern void SHIdleTimerReset();
		[DllImport("Coredll.dll")]
		private static extern void keybd_event(byte bVk, byte bScan, uint dwFlags,
			uint dwExtraInfo);
		[DllImport ("coredll.dll")] 
		private static extern IntPtr SetPowerRequirement (string pvDevice,int PowerState,int DeviceFlages,
			IntPtr pvSystemState,int StateFlags);
		[DllImport ("coredll.dll")] 
		private static extern int ReleasePowerRequirement (IntPtr handle);

		public void Dispose()
		{
			SIPChanged = null;
            BackLightNormal();
		}
		#region Clipboard
		private const int GMEM_FIXED = 0x0000;
		private const int LMEM_MOVEABLE = 2;
		private const int LMEM_ZEROINIT  = 0x0040;
		private const int LPTR = (GMEM_FIXED | LMEM_ZEROINIT);
		private IntPtr StringToHGlobalUni(string s)
		{
			if(s == null)
				return IntPtr.Zero;
	
			int i = (s.Length + 1) * System.Text.UnicodeEncoding.CharSize;
			
			IntPtr ptr = LocalAlloc(LPTR,(uint)i);

			byte[] data = Encoding.Unicode.GetBytes(s);
			Marshal.Copy(data, 0, ptr, data.Length);

			return ptr;
		}
		public string GetClipboardData()
		{
			string res = "";
			if(!OpenClipboard(IntPtr.Zero))
			{
				throw new System.Runtime.InteropServices.ExternalException("Could not open Clipboard");
			}
			if (IsClipboardFormatAvailable(13))
			{
				res =  Marshal.PtrToStringUni(GetClipboardData(13));
			}
			CloseClipboard();
			return res;
		}
		public void SetClipboardData(string Data)
		{
			if(!OpenClipboard(IntPtr.Zero))
				throw new System.Runtime.InteropServices.ExternalException("Could not open Clipboard");
			EmptyClipboard();
			IntPtr clip = StringToHGlobalUni(Data);
            if (SetClipboardData(13,clip) == IntPtr.Zero)
				throw new Exception("Error setting clipboard data.");
			CloseClipboard();
		}
		

		[DllImport("coredll.dll", EntryPoint="OpenClipboard", SetLastError=true)]   
		private static extern bool OpenClipboard(IntPtr hWndNewOwner);   
    
		[DllImport("coredll.dll", EntryPoint="CloseClipboard", SetLastError=true)]   
		private static extern bool CloseClipboard();   
    
		[DllImport("coredll.dll", EntryPoint="EmptyClipboard", SetLastError=true)]   
		private static extern bool EmptyClipboard();   
    
		[DllImport("coredll.dll", EntryPoint="IsClipboardFormatAvailable", SetLastError=true)]   
		private static extern bool IsClipboardFormatAvailable(int uFormat);   
    
		[DllImport("coredll.dll", EntryPoint="GetClipboardData", SetLastError=true)]   
		private static extern IntPtr GetClipboardData(uint uFormat);   
    
		[DllImport("coredll.dll", EntryPoint="SetClipboardData", SetLastError=true)]   
		private static extern IntPtr SetClipboardData(uint uFormat, IntPtr hMem);   

		[DllImport("coredll.dll",EntryPoint="LocalAlloc",SetLastError=true)]
		static extern IntPtr LocalAlloc(uint uFlags, uint Bytes);
		#endregion
		public string NetVersion
		{
			get {return System.Environment.Version.ToString();}
		}
		public string GetSpecialFolder(int folder)
		{
			StringBuilder path = new StringBuilder(262);
			if(!SHGetSpecialFolderPath(IntPtr.Zero, path, (int)folder, 0))
			{
				throw new Exception("Error retrieving folder path");
			}
			return path.ToString();
		}
		public long GCAllocatedMemory
		{
			get {return GC.GetTotalMemory(false);}
		}
		public void GCCollect()
		{
			GC.Collect();
		}

		public int sfPrograms		= 0x02;   
		public int sfPersonal		= 0x05;
		public int sfFavorites		= 0x06;
		public int sfStartup			= 0x07;
		public int sfStartMenu		= 0x0B;     
		public int sfFonts			= 0x14;
		public int sfWindows			= 0x24;
		public int sfProgramFiles	= 0x26;
		[DllImport("coredll.dll", EntryPoint="SHGetSpecialFolderPath", SetLastError=false)]
		internal static extern bool SHGetSpecialFolderPath(IntPtr hwndOwner, StringBuilder lpszPath, int nFolder, int fCreate);

		private void sip_EnabledChanged(object sender, EventArgs e)
		{
            if (SIPChanged != null)
				SIPChanged(eventObject,null);
		}

		private const uint EM_SETINPUTMODE = 0xDE;
		private const uint EIM_SPELL = 0;
		private const uint EIM_AMBIG = 1;
		private const uint EIM_NUMBERS = 2;

		[DllImport("coredll.dll")]
		private static extern IntPtr GetFocus();

		[DllImport("coredll.dll")]
		private static extern int SendMessage(IntPtr hWnd,
			uint Message, uint wParam, uint lParam);

		public void ChangeInputMode(bool Numeric)
		{
			IntPtr hWnd;
			hWnd = GetFocus();
			uint i;
			if (Numeric)
				i = 2;
			else
				i = 0;
			SendMessage(hWnd, EM_SETINPUTMODE, 0, i);
		}

		[DllImport ("BthUtil.dll")]
		private static extern int BthGetMode (out int dwMode);

		[DllImport("BthUtil.dll")]
		private static extern int BthSetMode(int dwMode);
		
		public int BluetoothMode
		{
			get
			{
				int r;
				if (BthGetMode(out r) != 0)
					throw new Exception("Error getting Bluetooth mode.");
				return r;
			}
			set
			{
				if (BthSetMode(value) != 0)
					throw new Exception("Error setting Bluetooth mode.");
			}
		}
		public int SendMessageToControl(Control Control,uint Msg, uint WParam, uint LParam)
		{
			Type t = Control.GetType();
			PropertyInfo pi = t.GetProperty("Handle");
			if (pi == null)
				throw new Exception("This method requires .Net 2.0.");
			IntPtr h = (IntPtr) pi.GetValue(Control,null);
			return SendMessage(h,Msg,WParam,LParam);
		}
		public void MouseClick(int x, int y)
		{
            int m1 = (int)Math.Round((double)65535 / Screen.PrimaryScreen.Bounds.Width);
			int m2 = (int)Math.Round((double)65535 / Screen.PrimaryScreen.Bounds.Height);
			x = x * m1;
			y = y * m2;
			mouse_event(2 | 0x8000,x,y,0,0);
			mouse_event(4 | 0x8000,x,y,0,0);
		}
		[DllImport("coredll.dll")]
		private static extern void mouse_event(int flags,int x, int y, int data, int extra);
		
		public void ShowNumericSIP()
		{
			if (sip == null)
				return;
			// Show panel if it is not shown yet
			if ( !((InputPanel)sip).Enabled )
			{
				((InputPanel)sip).Enabled = true;
				Application.DoEvents();
			}

			// Ensure that keyboard and not some of the other IMs is active
			Guid clsidKbdIM = new Guid("{42429667-ae04-11d0-a4f8-00aa00a749b9}");
			SipSetCurrentIM(clsidKbdIM.ToByteArray());

			// Find the SIP window
			IntPtr hWnd = FindWindow("SipWndClass", null);
			// Go one level below as the actual SIP window is a child
			hWnd = GetWindow(hWnd, GW_CHILD);
			// Obtain its context and get a color sample
			// The premise here is that the numeric mode is controlled by a virtual button in the top left corner
			// Whenever the numeric mode is active, the button background will be of COLOR_WINDOW_TEXT
			IntPtr hDC = GetDC(hWnd);
			int pixel = GetPixel(hDC,(int)(2 * scaleX), (int)(2 * scaleY));
			// Notice that we cannot simply compare the color to the system color as the system color is 24 bit (or palette)
			// and the real color is dithered to 15-16 bits for most devices, so white (0xff, 0xff, 0xff) becomes
			// almost white (oxf8, 0xfc, 0xf8)
			int clrText = (SystemColors.Window.R) | (SystemColors.Window.G << 8) | (SystemColors.Window.B << 16);
			SetPixel(hDC,(int)( 2 * scaleX),(int)( 2 * scaleY), clrText);
			int pixelNew = GetPixel(hDC, (int)(2 * scaleX),(int)( 2 * scaleY));
			// Restore the original pixel
			SetPixel(hDC,(int)( 2 * scaleX),(int)( 2 * scaleY), pixel);

			if ( pixel == pixelNew )
			{
				// Simulate stylus click
				Message msg = Message.Create(hWnd, WM_LBUTTONDOWN, new IntPtr(1), new IntPtr(0x00090009));
				MessageWindow.SendMessage(ref msg);
				msg = Message.Create(hWnd, WM_LBUTTONUP, new IntPtr(0), new IntPtr(0x00090009));
				MessageWindow.SendMessage(ref msg);
			}
			// Free resources
			ReleaseDC(hWnd, hDC);
		}
		public void ShowDefaultSIP()
		{
			if (sip == null)
				return;
			// Show panel if it is not shown yet
			if ( !((InputPanel)sip).Enabled )
			{
				((InputPanel)sip).Enabled = true;
				Application.DoEvents();
			}

			// Ensure that keyboard and not some of the other IMs is active
			Guid clsidKbdIM = new Guid("{42429667-ae04-11d0-a4f8-00aa00a749b9}");
			SipSetCurrentIM(clsidKbdIM.ToByteArray());
		}

		[DllImport("coredll")]
		private extern static IntPtr FindWindow(string wndClass, string caption);

		[DllImport("coredll")]
		private extern static IntPtr GetWindow(IntPtr hWnd, int nType);

		[DllImport("coredll")]
		private extern static int GetPixel(IntPtr hdc, int nXPos, 	int nYPos ); 
		
		[DllImport("coredll")]
		private extern static void SetPixel(IntPtr hdc, int nXPos, 	int nYPos, int clr); 

		[DllImport("Coredll.dll")]
		private static extern bool SipSetCurrentIM(byte[] clsid);

		private const int WM_LBUTTONDOWN                  = 0x0201;
		private const int WM_LBUTTONUP                    = 0x0202;
		private const int GW_CHILD						  = 5;

		[DllImport("coredll.dll", CharSet=CharSet.Auto)]
		private static extern bool ShowWindow(int hwnd, int nCmdShow);
		[DllImport("coredll.dll", CharSet=CharSet.Auto)]
		private static extern bool EnableWindow(int hwnd, bool enabled);

		public void HideTaskBar()
		{
			int h = FindWindow("HHTaskBar", "").ToInt32();
			ShowWindow(h, 0);
			EnableWindow(h, false); 
		}
	}

	public class HardKeys : MessageWindow
	{
		public event EventHandler HardKeyPressed;
		private object[] eventObject;
		private bool hardKeys, cursor;
		public int Key1 = 193;
		public int Key2 = 194;
		public int Key3 = 195;
		public int Key4 = 196;
		public int Key5 = 197;
		public int KeyLeft = 37;
		public int KeyRight = 39;
		public int KeyUp = 38;
		public int KeyDown = 40;
		public int KeyEnter = 13;
		public int KeyPressed;
		private int[] keys;
		public HardKeys(Form FormName,bool OnlyWhenFormIsActive, bool HardKeys, bool CursorKeys)
		{ 
			if (HardKeys)
				keys = new int[] {Key1,Key2,Key3,Key4,Key5};
			this.hardKeys = HardKeys;
			this.cursor = CursorKeys;
			if (OnlyWhenFormIsActive)
			{
				FormName.Activated += new EventHandler(FormName_Activated);
				FormName.Deactivate += new EventHandler(FormName_Deactivate);
			}
			Unregister(base.Hwnd);
			RegisterRecordKey(base.Hwnd);
			eventObject = new object[] {this,"HardKeyPressed"};
		}
		public HardKeys(Form FormName,bool OnlyWhenFormIsActive,int[] Keys, bool CursorKeys)
		{ 
			keys = Keys;
			this.hardKeys = true;
			this.cursor = CursorKeys;
			if (OnlyWhenFormIsActive)
			{
				FormName.Activated += new EventHandler(FormName_Activated);
				FormName.Deactivate += new EventHandler(FormName_Deactivate);
			}
			Unregister(base.Hwnd);
			RegisterRecordKey(base.Hwnd);
			eventObject = new object[] {this,"HardKeyPressed"};
		}
		private const int WM_HOTKEY=0x0312;

		protected override void WndProc(ref Message msg)
		{
			switch(msg.Msg)
			{ 
				case WM_HOTKEY:
					ButtonPressed(msg.WParam.ToInt32());
					return;
			}
			base.WndProc(ref msg);
		}

		private void ButtonPressed(int button)
		{
			KeyPressed = button;
			if (HardKeyPressed != null)
				HardKeyPressed(eventObject,null);
		}
		[DllImport("coredll.dll", SetLastError=true)]
		private static extern bool RegisterHotKey(
			IntPtr hWnd, // handle to window 
			int id, // hot key identifier 
			int Modifiers, // key-modifier options 
			int key //virtual-key code 
			); 

		[ DllImport("coredll.dll")]
		private static extern bool UnregisterFunc1(int 
			modifiers, int keyID); 

		private void RegisterRecordKey(IntPtr hWnd) 
		{
			if (hardKeys)
			{
				foreach (int k in keys)
				{
					RegisterHotKey(hWnd,k,8,k);
				}
			}
			if (cursor)
			{
				RegisterHotKey(hWnd, KeyLeft, 0, KeyLeft);
				RegisterHotKey(hWnd, KeyRight,0, KeyRight);
				RegisterHotKey(hWnd, KeyUp, 0, KeyUp);
				RegisterHotKey(hWnd, KeyDown, 0, KeyDown);
				RegisterHotKey(hWnd, KeyEnter, 0, KeyEnter);
			}
		}
		private void Unregister(IntPtr hWnd) 
		{
			if (hardKeys)
			{
				foreach (int k in keys)
				{
					UnregisterFunc1(8, k);
				}
			}
			if (cursor)
			{
				UnregisterFunc1(0, KeyLeft);
				UnregisterFunc1(0, KeyRight);
				UnregisterFunc1(0, KeyUp);
				UnregisterFunc1(0, KeyDown);
				UnregisterFunc1(0, KeyEnter);
			}
		}

		private void FormName_Activated(object sender, EventArgs e)
		{
			try
			{
				Unregister(base.Hwnd);
				RegisterRecordKey(base.Hwnd);
			}
			catch {}
		}

		private void FormName_Deactivate(object sender, EventArgs e)
		{
			try
			{
				Unregister(base.Hwnd);
			}
			catch {}
		}

	}
}
